/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { Base, markType, INotifyPropertyChanged_$type, PropertyChangedEventArgs } from "igniteui-react-core";
import { Size } from "igniteui-react-core";
import { ElevationHelper } from "igniteui-react-core";
import { Popup_OuterAnimationInfo } from "./Popup_OuterAnimationInfo";
import { Popup_InnerAnimationInfo } from "./Popup_InnerAnimationInfo";
import { AnimationKeyFrameEffect } from "igniteui-react-core";
import { AnimationKeyFrameEffectTiming } from "igniteui-react-core";
import { KeyFrameAnimationFactory } from "igniteui-react-core";
import { Rect } from "igniteui-react-core";
import { stringEmpty } from "igniteui-react-core";
import { stringFormat } from "igniteui-react-core";
import { OnClosedEventArgs } from "./OnClosedEventArgs";
import { List$1 } from "igniteui-react-core";
import { AnimationKeyFrameProperty } from "igniteui-react-core";
import { TranslateTransform } from "igniteui-react-core";
import { OnPopupEventArgs } from "./OnPopupEventArgs";
import { BrushUtil } from "igniteui-react-core";
import { truncate } from "igniteui-react-core";
/**
 * @hidden
 */
export let PopupView = /*@__PURE__*/ (() => {
    class PopupView extends Base {
        constructor() {
            super(...arguments);
            this.k = null;
            this.c = null;
            this.o = null;
            this.n = null;
            this.m = null;
            this.p = null;
            this.f = false;
            this.h = 0;
            this.ak = new Size(1, 0, 0);
            this.e = true;
            this.g = false;
        }
        get d() {
            return this.c;
        }
        get l() {
            return this.k;
        }
        ab() {
            this.o.setStyleProperty("height", "0%");
            this.o.setStyleProperty("width", "0%");
            this.n = this.k.createElement("div");
            this.n.setStyleProperty("position", "absolute");
            this.n.setStyleProperty("overflow", "hidden");
            this.n.setStyleProperty("z-index", "10000");
            this.n.setAttribute("key", "popupContentAreaOuter");
            this.m = this.k.createElement("div");
            this.m.setAttribute("key", "popupContentAreaInner");
            this.n.append(this.m);
        }
        ah() {
            let a = this.d;
            let b = ElevationHelper.e(a.v, a.a2, a.a1, a.a0);
            this.n.setStyleProperty("box-shadow", b);
        }
        ai() {
            if (null == this.o) {
                return;
            }
            this.ah();
        }
        s() {
            if (null != this.n) {
                this.ai();
                this.n.setStyleProperty("height", "0px");
                let a = this.n.getNativeElement();
                if (false == this.f) {
                    document.body.appendChild(a);
                    this.f = true;
                    if (this.e) {
                        this.z();
                    }
                }
            }
        }
        t(a, b) {
            this.n.setStyleProperty("top", PopupView.q(a.b));
            this.n.setStyleProperty("height", PopupView.r(a.d));
            this.m.setStyleProperty("top", PopupView.r(b.b));
            this.m.setStyleProperty("opacity", "1");
            this.m.setStyleProperty("transform", stringEmpty());
            this.h = 0;
            if (this.g) {
                this.ag();
            }
            return {
                p0: a,
                p1: b
            };
        }
        u(a) {
            this.h = a;
        }
        ae() {
            if (null != this.n && this.f) {
                let a = this.n.getNativeElement();
                document.body.removeChild(a);
                this.f = false;
            }
        }
        v(a) {
            this.m.append(a);
        }
        a(a) {
            return new AnimationKeyFrameEffect(0, this.m, 0, null, a);
        }
        b(a) {
            return new AnimationKeyFrameEffect(0, this.n, 0, null, a);
        }
        w() {
            if (KeyFrameAnimationFactory.h == null) {
                KeyFrameAnimationFactory.h = this.l;
            }
        }
        get al() {
            if (this.e) {
                this.z();
            }
            return this.ak;
        }
        i(a, b) {
            let c;
            let t1 = b;
            L0: while (true) {
                switch (t1) {
                    case 0:
                    case 1:
                        c = a.left;
                        break;
                    case 2:
                        c = a.right - this.al.width;
                        break;
                    default:
                        t1 = 0;
                        continue L0;
                }
                break;
            }
            return c;
        }
        j(a, b) {
            let c;
            let t1 = b;
            L0: while (true) {
                switch (t1) {
                    case 0:
                    case 1:
                        c = a.bottom;
                        break;
                    case 2:
                        c = a.top - this.al.height;
                        break;
                    default:
                        t1 = 0;
                        continue L0;
                }
                break;
            }
            return c;
        }
        static r(a) {
            return stringFormat("{0}px", a);
        }
        static q(a) {
            return stringFormat("{0}px", a);
        }
        aj(a, b, c) {
            let d = this.j(a, b);
            let e = this.i(a, c);
            this.af(e, d);
            if (b == 2 || c == 2) {
                let f = 10;
                while (f > 0) {
                    let g = this.j(a, b);
                    let h = this.i(a, c);
                    if (g == d && h == e) {
                        f = 0;
                        break;
                    }
                    d = g;
                    e = h;
                    this.af(e, d);
                    f--;
                }
            }
            return new Rect(0, e, d, this.al.width, this.al.height);
        }
        z() {
            if (this.f) {
                this.n.setStyleProperty("width", stringEmpty());
                this.n.setStyleProperty("height", stringEmpty());
                this.ak = new Size(1, this.m.outerWidth(), this.m.outerHeight());
                this.e = false;
                this.ag();
            }
            else {
                this.e = true;
            }
        }
        af(a, b) {
            let c = stringFormat("{0}px", a);
            let d = stringFormat("{0}px", b);
            this.n.setStyleProperty("left", c);
            this.n.setStyleProperty("top", d);
        }
        ac(a) {
            if (a == null) {
                this.k = null;
                return;
            }
            this.k = a;
            let b = a.rootWrapper;
            this.x(b);
            this.k.getPortal(this.m, "ChildContent", (c) => {
                let comp_ = c.componentRef;
                this.p = comp_;
            }, true);
        }
        ag() {
            let a = new Size(1, this.al.width, this.al.height);
            if (!this.f || !this.d.s) {
                a.height = 0;
            }
            let b = a.width;
            let c = a.height;
            if (this.c.q()) {
                if (this.h == c) {
                    return;
                }
                this.c.aj();
                this.g = true;
                return;
            }
            this.g = false;
            let d = stringFormat("{0}px", b);
            let e = stringFormat("{0}px", c);
            this.n.setStyleProperty("width", d);
            this.n.setStyleProperty("height", e);
        }
        x(a) {
            this.o = a;
            this.ab();
        }
        y(a) {
            this.c = a;
        }
        aa() {
        }
        ad() {
            this.s();
            if (this.d.s) {
                return;
            }
            this.ag();
        }
    }
    PopupView.$t = /*@__PURE__*/ markType(PopupView, 'PopupView');
    return PopupView;
})();
/**
 * @hidden
 */
export let Popup = /*@__PURE__*/ (() => {
    class Popup extends Base {
        constructor() {
            super();
            this.h = 0;
            this.g = 0;
            this.a6 = null;
            this.m = null;
            this.n = null;
            this.onClosed = null;
            this.onPopup = null;
            this.propertyChanged = null;
            this.j = null;
            this.w = 50;
            this.o = true;
            this.u = -1;
            this.t = Popup.y;
            this.r = false;
            this.az = Popup.a5;
            this.ay = Popup.a4;
            this.ax = Popup.a3;
            let a = this.i();
            this.j = a;
            a.y(this);
        }
        aq(a, b, c) {
            if (this.propertyChanged != null) {
                this.propertyChanged(this, new PropertyChangedEventArgs(a));
            }
            this.as(a, b, c);
        }
        get x() {
            return this.w;
        }
        set x(a) {
            let b = this.w;
            this.w = a;
            if (b != this.w) {
                this.aq("AnimationDuration", b, a);
            }
        }
        get p() {
            return this.o;
        }
        set p(a) {
            let b = this.o;
            this.o = a;
            if (b != this.o) {
                this.aq("AnimationEnabled", b, a);
            }
        }
        get z() {
            return this.u;
        }
        set z(a) {
            let b = this.u;
            this.u = a;
            if (b != this.u) {
                this.aq("Elevation", b, a);
            }
        }
        get v() {
            return this.t;
        }
        set v(a) {
            let b = this.t;
            this.t = a;
            if (b != this.t) {
                this.aq("ActualElevation", b, a);
            }
        }
        get s() {
            return this.r;
        }
        get a2() {
            return this.az;
        }
        set a2(a) {
            let b = this.az;
            this.az = a;
            if (b != this.az) {
                this.aq("ActualUmbraShadowColor", b, a);
            }
        }
        get a1() {
            return this.ay;
        }
        set a1(a) {
            let b = this.ay;
            this.ay = a;
            if (b != this.ay) {
                this.aq("ActualPenumbraShadowColor", b, a);
            }
        }
        get a0() {
            return this.ax;
        }
        set a0(a) {
            let b = this.ax;
            this.ax = a;
            if (b != this.ax) {
                this.aq("ActualAmbientShadowColor", b, a);
            }
        }
        i() {
            return new PopupView();
        }
        as(a, b, c) {
            switch (a) {
                case "IsShown":
                    if (false == this.s) {
                        this.j.ae();
                    }
                    break;
                case "Elevation":
                    this.v = this.z == -1 ? Popup.y : this.z;
                    break;
                case "ActualElevation":
                case "ActualUmbraShadowColor":
                case "ActualPenumbraShadowColor":
                case "ActualAmbientShadowColor":
                    this.j.ai();
                    break;
                case "AnimationEnabled":
                    if (false == this.p) {
                        this.aj();
                    }
                    break;
            }
        }
        aj() {
            if (this.q()) {
                if (null != this.n && this.n.playState == 1) {
                    this.n.cancel();
                }
                if (null != this.m && this.m.playState == 1) {
                    this.m.cancel();
                }
            }
        }
        k(a) {
            let b = this.e(a);
            let c = a ? this.b() : this.a();
            let d = this.j.a(c);
            let e = new List$1(AnimationKeyFrameProperty.$, 0);
            let f = new List$1(AnimationKeyFrameProperty.$, 0);
            let g = new TranslateTransform();
            g.k = b.a;
            let h = new TranslateTransform();
            h.k = b.b;
            let i = new AnimationKeyFrameProperty(14, g);
            let j = new AnimationKeyFrameProperty(14, h);
            e.add(i);
            f.add(j);
            d.m(...e.toArray());
            d.m(...f.toArray());
            return KeyFrameAnimationFactory.f.c(d);
        }
        l(a) {
            let b = this.f(a);
            this.j.u(b.d);
            let c = a ? this.b() : this.a();
            let d = this.j.b(c);
            let e = new List$1(AnimationKeyFrameProperty.$, 0);
            let f = new List$1(AnimationKeyFrameProperty.$, 0);
            let g = new AnimationKeyFrameProperty(10, b.c);
            let h = new AnimationKeyFrameProperty(10, b.d);
            e.add(g);
            f.add(h);
            if (this.h == 2) {
                let i = b.a;
                let j = b.b;
                let k = new AnimationKeyFrameProperty(12, i);
                let l = new AnimationKeyFrameProperty(12, j);
                e.add(k);
                f.add(l);
            }
            d.m(...e.toArray());
            d.m(...f.toArray());
            return KeyFrameAnimationFactory.f.c(d);
        }
        a() {
            let a = new AnimationKeyFrameEffectTiming();
            a.g = this.x;
            a.b = 3;
            return a;
        }
        b() {
            let a = new AnimationKeyFrameEffectTiming();
            a.g = this.x;
            a.b = 3;
            return a;
        }
        am() {
            this.j.w();
        }
        e(a) {
            let b = truncate(this.j.al.height);
            if (b <= 0) {
                b = 500;
            }
            let c = a ? -b : 0;
            let d = a ? 0 : -b;
            if (this.h == 2) {
                c = 0;
                d = 0;
            }
            let e = ((() => {
                let $ret = new Popup_InnerAnimationInfo();
                $ret.a = c;
                $ret.b = d;
                return $ret;
            })());
            return e;
        }
        f(a) {
            let b = truncate(this.j.al.height);
            if (b <= 0) {
                b = 500;
            }
            let c = a ? 0 : b;
            let d = a ? b : 0;
            let e;
            let f;
            if (this.h == 2) {
                e = a ? this.a6.bottom : this.a6.top;
                f = a ? this.a6.top : this.a6.bottom;
            }
            else {
                e = this.a6.top;
                f = this.a6.top;
            }
            let g = ((() => {
                let $ret = new Popup_OuterAnimationInfo();
                $ret.c = c;
                $ret.d = d;
                $ret.a = e;
                $ret.b = f;
                return $ret;
            })());
            return g;
        }
        q() {
            if (null == this.n && null == this.m) {
                return false;
            }
            if (null != this.n && this.n.playState == 1) {
                return true;
            }
            if (null != this.m && this.m.playState == 1) {
                return true;
            }
            return false;
        }
        an() {
            this.j.z();
        }
        ar(a, b, c) {
            this.j.ad();
            this.a6 = this.j.aj(a, b, c);
            this.h = b;
            this.g = c;
        }
        au(a, b, c) {
            if (this.r) {
                this.r = false;
                this.aq("IsShown", true, this.r);
            }
            this.ar(a, b, c);
            this.av(true);
        }
        av(a) {
            this.aj();
            let b = this.r;
            this.r = a;
            let c = this.f(a);
            let d = this.e(a);
            if (false == this.p) {
                let e = this.j.t(c, d);
                c = e.p0;
                d = e.p1;
                return;
            }
            this.am();
            this.m = this.k(this.r);
            this.n = this.l(this.r);
            this.m.play();
            this.n.play();
            this.m.finished.f((f) => this.m.commitStyles());
            this.n.finished.f((f) => {
                this.n.commitStyles();
                this.aq("IsShown", b, this.r);
                if (this.r) {
                    if (this.onPopup != null) {
                        this.onPopup(this, new OnPopupEventArgs());
                    }
                }
                else {
                    if (this.onClosed != null) {
                        this.onClosed(this, new OnClosedEventArgs());
                    }
                }
                let g = this.j.t(c, d);
                c = g.p0;
                d = g.p1;
            });
        }
        appendPopupContent(a) {
            this.j.v(a);
        }
        ak() {
            if (!this.r) {
                return;
            }
            this.av(false);
        }
        destroy() {
            this.provideRenderer(null);
        }
        showRelativeToExclusionRect(a, b, c) {
            this.au(a, b, c);
        }
        ao(a) {
            this.a6 = this.j.aj(a, this.h, this.g);
        }
        notifySizeChanged() {
        }
        provideRenderer(a) {
            this.j.ac(a);
        }
    }
    Popup.$t = /*@__PURE__*/ markType(Popup, 'Popup', Base.$, [INotifyPropertyChanged_$type]);
    Popup.y = 2;
    Popup.a5 = /*@__PURE__*/ BrushUtil.g(66, 0, 0, 0);
    Popup.a4 = /*@__PURE__*/ BrushUtil.g(30, 0, 0, 0);
    Popup.a3 = /*@__PURE__*/ BrushUtil.g(20, 0, 0, 0);
    return Popup;
})();
//# sourceMappingURL=PopupView_combined.js.map
