/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import * as tslib_1 from "tslib";
import { Base, markType, INotifyPropertyChanged_$type, PropertyChangedEventArgs } from "igniteui-react-core";
import { Size } from "igniteui-react-core";
import { ElevationHelper } from "igniteui-react-core";
import { Popup_OuterAnimationInfo } from "./Popup_OuterAnimationInfo";
import { Popup_InnerAnimationInfo } from "./Popup_InnerAnimationInfo";
import { AnimationKeyFrameEffect } from "igniteui-react-core";
import { AnimationKeyFrameEffectTiming } from "igniteui-react-core";
import { KeyFrameAnimationFactory } from "igniteui-react-core";
import { Rect } from "igniteui-react-core";
import { stringEmpty } from "igniteui-react-core";
import { stringFormat } from "igniteui-react-core";
import { OnClosedEventArgs } from "./OnClosedEventArgs";
import { List$1 } from "igniteui-react-core";
import { AnimationKeyFrameProperty } from "igniteui-react-core";
import { TranslateTransform } from "igniteui-react-core";
import { OnPopupEventArgs } from "./OnPopupEventArgs";
import { BrushUtil } from "igniteui-react-core";
import { truncate } from "igniteui-react-core";
/**
 * @hidden
 */
var PopupView = /** @class */ /*@__PURE__*/ (function (_super) {
    tslib_1.__extends(PopupView, _super);
    function PopupView() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.k = null;
        _this.c = null;
        _this.o = null;
        _this.n = null;
        _this.m = null;
        _this.p = null;
        _this.f = false;
        _this.h = 0;
        _this.ak = new Size(1, 0, 0);
        _this.e = true;
        _this.g = false;
        return _this;
    }
    Object.defineProperty(PopupView.prototype, "d", {
        get: function () {
            return this.c;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PopupView.prototype, "l", {
        get: function () {
            return this.k;
        },
        enumerable: true,
        configurable: true
    });
    PopupView.prototype.ab = function () {
        this.o.setStyleProperty("height", "0%");
        this.o.setStyleProperty("width", "0%");
        this.n = this.k.createElement("div");
        this.n.setStyleProperty("position", "absolute");
        this.n.setStyleProperty("overflow", "hidden");
        this.n.setStyleProperty("z-index", "10000");
        this.n.setAttribute("key", "popupContentAreaOuter");
        this.m = this.k.createElement("div");
        this.m.setAttribute("key", "popupContentAreaInner");
        this.n.append(this.m);
    };
    PopupView.prototype.ah = function () {
        var a = this.d;
        var b = ElevationHelper.e(a.v, a.a2, a.a1, a.a0);
        this.n.setStyleProperty("box-shadow", b);
    };
    PopupView.prototype.ai = function () {
        if (null == this.o) {
            return;
        }
        this.ah();
    };
    PopupView.prototype.s = function () {
        if (null != this.n) {
            this.ai();
            this.n.setStyleProperty("height", "0px");
            var a = this.n.getNativeElement();
            if (false == this.f) {
                document.body.appendChild(a);
                this.f = true;
                if (this.e) {
                    this.z();
                }
            }
        }
    };
    PopupView.prototype.t = function (a, b) {
        this.n.setStyleProperty("top", PopupView.q(a.b));
        this.n.setStyleProperty("height", PopupView.r(a.d));
        this.m.setStyleProperty("top", PopupView.r(b.b));
        this.m.setStyleProperty("opacity", "1");
        this.m.setStyleProperty("transform", stringEmpty());
        this.h = 0;
        if (this.g) {
            this.ag();
        }
        return {
            p0: a,
            p1: b
        };
    };
    PopupView.prototype.u = function (a) {
        this.h = a;
    };
    PopupView.prototype.ae = function () {
        if (null != this.n && this.f) {
            var a = this.n.getNativeElement();
            document.body.removeChild(a);
            this.f = false;
        }
    };
    PopupView.prototype.v = function (a) {
        this.m.append(a);
    };
    PopupView.prototype.a = function (a) {
        return new AnimationKeyFrameEffect(0, this.m, 0, null, a);
    };
    PopupView.prototype.b = function (a) {
        return new AnimationKeyFrameEffect(0, this.n, 0, null, a);
    };
    PopupView.prototype.w = function () {
        if (KeyFrameAnimationFactory.h == null) {
            KeyFrameAnimationFactory.h = this.l;
        }
    };
    Object.defineProperty(PopupView.prototype, "al", {
        get: function () {
            if (this.e) {
                this.z();
            }
            return this.ak;
        },
        enumerable: true,
        configurable: true
    });
    PopupView.prototype.i = function (a, b) {
        var c;
        var t1 = b;
        L0: while (true) {
            switch (t1) {
                case 0:
                case 1:
                    c = a.left;
                    break;
                case 2:
                    c = a.right - this.al.width;
                    break;
                default:
                    t1 = 0;
                    continue L0;
            }
            break;
        }
        return c;
    };
    PopupView.prototype.j = function (a, b) {
        var c;
        var t1 = b;
        L0: while (true) {
            switch (t1) {
                case 0:
                case 1:
                    c = a.bottom;
                    break;
                case 2:
                    c = a.top - this.al.height;
                    break;
                default:
                    t1 = 0;
                    continue L0;
            }
            break;
        }
        return c;
    };
    PopupView.r = function (a) {
        return stringFormat("{0}px", a);
    };
    PopupView.q = function (a) {
        return stringFormat("{0}px", a);
    };
    PopupView.prototype.aj = function (a, b, c) {
        var d = this.j(a, b);
        var e = this.i(a, c);
        this.af(e, d);
        if (b == 2 || c == 2) {
            var f = 10;
            while (f > 0) {
                var g = this.j(a, b);
                var h = this.i(a, c);
                if (g == d && h == e) {
                    f = 0;
                    break;
                }
                d = g;
                e = h;
                this.af(e, d);
                f--;
            }
        }
        return new Rect(0, e, d, this.al.width, this.al.height);
    };
    PopupView.prototype.z = function () {
        if (this.f) {
            this.n.setStyleProperty("width", stringEmpty());
            this.n.setStyleProperty("height", stringEmpty());
            this.ak = new Size(1, this.m.outerWidth(), this.m.outerHeight());
            this.e = false;
            this.ag();
        }
        else {
            this.e = true;
        }
    };
    PopupView.prototype.af = function (a, b) {
        var c = stringFormat("{0}px", a);
        var d = stringFormat("{0}px", b);
        this.n.setStyleProperty("left", c);
        this.n.setStyleProperty("top", d);
    };
    PopupView.prototype.ac = function (a) {
        var _this = this;
        if (a == null) {
            this.k = null;
            return;
        }
        this.k = a;
        var b = a.rootWrapper;
        this.x(b);
        this.k.getPortal(this.m, "ChildContent", function (c) {
            var comp_ = c.componentRef;
            _this.p = comp_;
        }, true);
    };
    PopupView.prototype.ag = function () {
        var a = new Size(1, this.al.width, this.al.height);
        if (!this.f || !this.d.s) {
            a.height = 0;
        }
        var b = a.width;
        var c = a.height;
        if (this.c.q()) {
            if (this.h == c) {
                return;
            }
            this.c.aj();
            this.g = true;
            return;
        }
        this.g = false;
        var d = stringFormat("{0}px", b);
        var e = stringFormat("{0}px", c);
        this.n.setStyleProperty("width", d);
        this.n.setStyleProperty("height", e);
    };
    PopupView.prototype.x = function (a) {
        this.o = a;
        this.ab();
    };
    PopupView.prototype.y = function (a) {
        this.c = a;
    };
    PopupView.prototype.aa = function () {
    };
    PopupView.prototype.ad = function () {
        this.s();
        if (this.d.s) {
            return;
        }
        this.ag();
    };
    PopupView.$t = markType(PopupView, 'PopupView');
    return PopupView;
}(Base));
export { PopupView };
/**
 * @hidden
 */
var Popup = /** @class */ /*@__PURE__*/ (function (_super) {
    tslib_1.__extends(Popup, _super);
    function Popup() {
        var _this = _super.call(this) || this;
        _this.h = 0;
        _this.g = 0;
        _this.a6 = null;
        _this.m = null;
        _this.n = null;
        _this.onClosed = null;
        _this.onPopup = null;
        _this.propertyChanged = null;
        _this.j = null;
        _this.w = 50;
        _this.o = true;
        _this.u = -1;
        _this.t = Popup.y;
        _this.r = false;
        _this.az = Popup.a5;
        _this.ay = Popup.a4;
        _this.ax = Popup.a3;
        var a = _this.i();
        _this.j = a;
        a.y(_this);
        return _this;
    }
    Popup.prototype.aq = function (a, b, c) {
        if (this.propertyChanged != null) {
            this.propertyChanged(this, new PropertyChangedEventArgs(a));
        }
        this.as(a, b, c);
    };
    Object.defineProperty(Popup.prototype, "x", {
        get: function () {
            return this.w;
        },
        set: function (a) {
            var b = this.w;
            this.w = a;
            if (b != this.w) {
                this.aq("AnimationDuration", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Popup.prototype, "p", {
        get: function () {
            return this.o;
        },
        set: function (a) {
            var b = this.o;
            this.o = a;
            if (b != this.o) {
                this.aq("AnimationEnabled", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Popup.prototype, "z", {
        get: function () {
            return this.u;
        },
        set: function (a) {
            var b = this.u;
            this.u = a;
            if (b != this.u) {
                this.aq("Elevation", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Popup.prototype, "v", {
        get: function () {
            return this.t;
        },
        set: function (a) {
            var b = this.t;
            this.t = a;
            if (b != this.t) {
                this.aq("ActualElevation", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Popup.prototype, "s", {
        get: function () {
            return this.r;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Popup.prototype, "a2", {
        get: function () {
            return this.az;
        },
        set: function (a) {
            var b = this.az;
            this.az = a;
            if (b != this.az) {
                this.aq("ActualUmbraShadowColor", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Popup.prototype, "a1", {
        get: function () {
            return this.ay;
        },
        set: function (a) {
            var b = this.ay;
            this.ay = a;
            if (b != this.ay) {
                this.aq("ActualPenumbraShadowColor", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Popup.prototype, "a0", {
        get: function () {
            return this.ax;
        },
        set: function (a) {
            var b = this.ax;
            this.ax = a;
            if (b != this.ax) {
                this.aq("ActualAmbientShadowColor", b, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    Popup.prototype.i = function () {
        return new PopupView();
    };
    Popup.prototype.as = function (a, b, c) {
        switch (a) {
            case "IsShown":
                if (false == this.s) {
                    this.j.ae();
                }
                break;
            case "Elevation":
                this.v = this.z == -1 ? Popup.y : this.z;
                break;
            case "ActualElevation":
            case "ActualUmbraShadowColor":
            case "ActualPenumbraShadowColor":
            case "ActualAmbientShadowColor":
                this.j.ai();
                break;
            case "AnimationEnabled":
                if (false == this.p) {
                    this.aj();
                }
                break;
        }
    };
    Popup.prototype.aj = function () {
        if (this.q()) {
            if (null != this.n && this.n.playState == 1) {
                this.n.cancel();
            }
            if (null != this.m && this.m.playState == 1) {
                this.m.cancel();
            }
        }
    };
    Popup.prototype.k = function (a) {
        var b = this.e(a);
        var c = a ? this.b() : this.a();
        var d = this.j.a(c);
        var e = new List$1(AnimationKeyFrameProperty.$, 0);
        var f = new List$1(AnimationKeyFrameProperty.$, 0);
        var g = new TranslateTransform();
        g.k = b.a;
        var h = new TranslateTransform();
        h.k = b.b;
        var i = new AnimationKeyFrameProperty(14, g);
        var j = new AnimationKeyFrameProperty(14, h);
        e.add(i);
        f.add(j);
        d.m.apply(d, tslib_1.__spread(e.toArray()));
        d.m.apply(d, tslib_1.__spread(f.toArray()));
        return KeyFrameAnimationFactory.f.c(d);
    };
    Popup.prototype.l = function (a) {
        var b = this.f(a);
        this.j.u(b.d);
        var c = a ? this.b() : this.a();
        var d = this.j.b(c);
        var e = new List$1(AnimationKeyFrameProperty.$, 0);
        var f = new List$1(AnimationKeyFrameProperty.$, 0);
        var g = new AnimationKeyFrameProperty(10, b.c);
        var h = new AnimationKeyFrameProperty(10, b.d);
        e.add(g);
        f.add(h);
        if (this.h == 2) {
            var i = b.a;
            var j = b.b;
            var k = new AnimationKeyFrameProperty(12, i);
            var l = new AnimationKeyFrameProperty(12, j);
            e.add(k);
            f.add(l);
        }
        d.m.apply(d, tslib_1.__spread(e.toArray()));
        d.m.apply(d, tslib_1.__spread(f.toArray()));
        return KeyFrameAnimationFactory.f.c(d);
    };
    Popup.prototype.a = function () {
        var a = new AnimationKeyFrameEffectTiming();
        a.g = this.x;
        a.b = 3;
        return a;
    };
    Popup.prototype.b = function () {
        var a = new AnimationKeyFrameEffectTiming();
        a.g = this.x;
        a.b = 3;
        return a;
    };
    Popup.prototype.am = function () {
        this.j.w();
    };
    Popup.prototype.e = function (a) {
        var b = truncate(this.j.al.height);
        if (b <= 0) {
            b = 500;
        }
        var c = a ? -b : 0;
        var d = a ? 0 : -b;
        if (this.h == 2) {
            c = 0;
            d = 0;
        }
        var e = ((function () {
            var $ret = new Popup_InnerAnimationInfo();
            $ret.a = c;
            $ret.b = d;
            return $ret;
        })());
        return e;
    };
    Popup.prototype.f = function (a) {
        var b = truncate(this.j.al.height);
        if (b <= 0) {
            b = 500;
        }
        var c = a ? 0 : b;
        var d = a ? b : 0;
        var e;
        var f;
        if (this.h == 2) {
            e = a ? this.a6.bottom : this.a6.top;
            f = a ? this.a6.top : this.a6.bottom;
        }
        else {
            e = this.a6.top;
            f = this.a6.top;
        }
        var g = ((function () {
            var $ret = new Popup_OuterAnimationInfo();
            $ret.c = c;
            $ret.d = d;
            $ret.a = e;
            $ret.b = f;
            return $ret;
        })());
        return g;
    };
    Popup.prototype.q = function () {
        if (null == this.n && null == this.m) {
            return false;
        }
        if (null != this.n && this.n.playState == 1) {
            return true;
        }
        if (null != this.m && this.m.playState == 1) {
            return true;
        }
        return false;
    };
    Popup.prototype.an = function () {
        this.j.z();
    };
    Popup.prototype.ar = function (a, b, c) {
        this.j.ad();
        this.a6 = this.j.aj(a, b, c);
        this.h = b;
        this.g = c;
    };
    Popup.prototype.au = function (a, b, c) {
        if (this.r) {
            this.r = false;
            this.aq("IsShown", true, this.r);
        }
        this.ar(a, b, c);
        this.av(true);
    };
    Popup.prototype.av = function (a) {
        var _this = this;
        this.aj();
        var b = this.r;
        this.r = a;
        var c = this.f(a);
        var d = this.e(a);
        if (false == this.p) {
            var e = this.j.t(c, d);
            c = e.p0;
            d = e.p1;
            return;
        }
        this.am();
        this.m = this.k(this.r);
        this.n = this.l(this.r);
        this.m.play();
        this.n.play();
        this.m.finished.f(function (f) { return _this.m.commitStyles(); });
        this.n.finished.f(function (f) {
            _this.n.commitStyles();
            _this.aq("IsShown", b, _this.r);
            if (_this.r) {
                if (_this.onPopup != null) {
                    _this.onPopup(_this, new OnPopupEventArgs());
                }
            }
            else {
                if (_this.onClosed != null) {
                    _this.onClosed(_this, new OnClosedEventArgs());
                }
            }
            var g = _this.j.t(c, d);
            c = g.p0;
            d = g.p1;
        });
    };
    Popup.prototype.appendPopupContent = function (a) {
        this.j.v(a);
    };
    Popup.prototype.ak = function () {
        if (!this.r) {
            return;
        }
        this.av(false);
    };
    Popup.prototype.destroy = function () {
        this.provideRenderer(null);
    };
    Popup.prototype.showRelativeToExclusionRect = function (a, b, c) {
        this.au(a, b, c);
    };
    Popup.prototype.ao = function (a) {
        this.a6 = this.j.aj(a, this.h, this.g);
    };
    Popup.prototype.notifySizeChanged = function () {
    };
    Popup.prototype.provideRenderer = function (a) {
        this.j.ac(a);
    };
    Popup.$t = markType(Popup, 'Popup', Base.$, [INotifyPropertyChanged_$type]);
    Popup.y = 2;
    Popup.a5 = BrushUtil.g(66, 0, 0, 0);
    Popup.a4 = BrushUtil.g(30, 0, 0, 0);
    Popup.a3 = BrushUtil.g(20, 0, 0, 0);
    return Popup;
}(Base));
export { Popup };
//# sourceMappingURL=PopupView_combined.js.map
