import { Base, Type, INotifyPropertyChanged, PropertyChangedEventArgs } from "igniteui-react-core";
import { DomRenderer, DomWrapper } from "igniteui-react-core";
import { Size } from "igniteui-react-core";
import { Popup_OuterAnimationInfo } from "./Popup_OuterAnimationInfo";
import { Popup_InnerAnimationInfo } from "./Popup_InnerAnimationInfo";
import { AnimationKeyFrameEffect } from "igniteui-react-core";
import { AnimationKeyFrameEffectTiming } from "igniteui-react-core";
import { Rect } from "igniteui-react-core";
import { PopupAlignment } from "./PopupAlignment";
import { PopupDirection } from "./PopupDirection";
import { Brush } from "igniteui-react-core";
import { OnClosedEventArgs } from "./OnClosedEventArgs";
import { OnPopupEventArgs } from "./OnPopupEventArgs";
/**
 * @hidden
 */
export declare class PopupView extends Base {
    static $t: Type;
    private k;
    private c;
    private o;
    private n;
    private m;
    private p;
    private f;
    private h;
    protected readonly d: Popup;
    protected readonly l: DomRenderer;
    protected ab(): void;
    ah(): void;
    ai(): void;
    s(): void;
    t(a: Popup_OuterAnimationInfo, b: Popup_InnerAnimationInfo): {
        p0?: Popup_OuterAnimationInfo;
        p1?: Popup_InnerAnimationInfo;
    };
    u(a: number): void;
    ae(): void;
    v(a: any): void;
    a(a: AnimationKeyFrameEffectTiming): AnimationKeyFrameEffect;
    b(a: AnimationKeyFrameEffectTiming): AnimationKeyFrameEffect;
    w(): void;
    private ak;
    readonly al: Size;
    private i;
    private j;
    private static r;
    private static q;
    aj(a: Rect, b: PopupDirection, c: PopupAlignment): Rect;
    private e;
    z(): void;
    private af;
    ac(a: DomRenderer): void;
    private g;
    private ag;
    protected x(a: DomWrapper): void;
    y(a: Popup): void;
    aa(): void;
    ad(): void;
}
/**
 * @hidden
 */
export declare class Popup extends Base implements INotifyPropertyChanged {
    static $t: Type;
    private h;
    private g;
    private a6;
    private m;
    private n;
    constructor();
    onClosed: (sender: any, args: OnClosedEventArgs) => void;
    onPopup: (sender: any, args: OnPopupEventArgs) => void;
    propertyChanged: (sender: any, e: PropertyChangedEventArgs) => void;
    protected aq(a: string, b: any, c: any): void;
    j: PopupView;
    private w;
    x: number;
    private o;
    p: boolean;
    private u;
    z: number;
    private static y;
    private t;
    v: number;
    private r;
    readonly s: boolean;
    private static a5;
    private az;
    a2: Brush;
    private static a4;
    private ay;
    a1: Brush;
    private static a3;
    private ax;
    a0: Brush;
    protected i(): PopupView;
    protected as(a: string, b: any, c: any): void;
    aj(): void;
    private k;
    private l;
    private a;
    private b;
    private am;
    private e;
    private f;
    q(): boolean;
    an(): void;
    private ar;
    private au;
    private av;
    appendPopupContent(a: any): void;
    ak(): void;
    destroy(): void;
    showRelativeToExclusionRect(a: Rect, b: PopupDirection, c: PopupAlignment): void;
    ao(a: Rect): void;
    notifySizeChanged(): void;
    provideRenderer(a: DomRenderer): void;
}
